import re

import markdown

from django import template
from django.template.defaultfilters import stringfilter
from django.utils.safestring import mark_safe

register = template.Library()

# =============================================================================
# filter to truncate and annotate text
# =============================================================================

@register.filter("format")
@stringfilter
def format(s, templates=None):
    
    for name, value in templates and templates.items() or []:
        s = re.sub(r'\{\{ *%s *\}\}' % name, value, s)
    s = re.sub(r'\n +', '\n', s)
    ### if python >= 2.6:
    #s = s if isinstance(s, unicode) else unicode(s, encoding='utf-8')
    ### else:
    if not isinstance(s, unicode): s = unicode(s, encoding='utf-8')
    ### endif
    s = markdown.markdown(s)

    return mark_safe(s)

