# -*- encoding: utf-8 -*-

import imp
import os.path

def strcut(s, mlen=72):

    return len(s) > mlen and "%s.." % s[:70] or s

class AttributeDict(dict):

    def __getattribute__(self, name):
        """Attribute-style access to items."""

        try:
            return super(AttributeDict, self).__getattribute__(name)
        except AttributeError, e:
            if name in self:
                return self[name]
            raise e

    def __setattr__(self, name, value):
        """Attribute-style access to items."""

        self[name] = value

    def copy(self):
        """Create a copy of this AttributeDict.

        Note that all recursively contained dicts, lists or sets will be copied
        to!

        """
        return adify(self)

    def __repr__(self):

        s = []
        for k in sorted(self.keys()):
            s.append("%r:%r" % (k, self[k]))
        return "{%s}" % ",".join(s)

def adify(o):
    """Recursively transform dicts to AttributeDict objects.

    If o is a dict, it's converted to an AttributeDict. If o is a list or a
    set, it's elements get 'adified' recursively. If o is something different,
    nothing is done but o itself is returned.

    Note that if o is a dict, list or set, this function creates copies of o!

    """
    if isinstance(o, dict):
        o = AttributeDict(o)
        for key, val in o.items():
            o[key] = adify(val)
    elif isinstance(o, list):
        o = [adify(e) for e in o]
    elif isinstance(o, set):
        o = set([adify(e) for e in o])
    else:
        pass

    return o

def impmod(fname):
    """Import a Python file as a (package-free) module."""

    name = os.path.basename(fname).rsplit(".py", 1)[0]
    mod = imp.load_source(name, fname)
    return mod

def meanstdv(x):
    """Calculate mean and standard deviation.

    mean = {\sum_i x_i \over n}
    std = sqrt(\sum_i (x_i - mean)^2 \over n-1)

    """
    from math import sqrt
    n, mean, std = len(x), 0, 0
    for a in x:
        mean = mean + a
    mean = mean / float(n)
    for a in x:
        std = std + (a - mean)**2
    std = sqrt(std / float(n-1))
    return mean, std
